Subject: [PATCH/WIP v2 00/14] inotify support

From: Nguyễn Thái Ngọc Duy <[email-masked]>
Date: Fri, 17 Jan 2014 16:47:26 +0700

This is getting in better shape. Still wondering if the design is
right, so documentation, tests and some error cases are still
neglected. I have not addressed Jonathan's and Jeff's comments in this
reroll, but I haven't forgotten them yet. The test suite seems to be
fine when file-watcher is forced on with GIT_TEST_FORCE_WATCHER set..

Thomas, you were a proponent of per-user daemon last time. I agree
that is a better solution when you need to support submodules. So if
you have time, have a look and see if anything I did may prevent
per-user daemon changes later (hint, I have a few unfriendly exit() in
file-watcher.c). You also worked with inotify before maybe you can
help spot some mishandling too as I'm totally new to inotify.

Nguyễn Thái Ngọc Duy (14):
  read-cache: save trailing sha-1
  read-cache: new extension to mark what file is watched
  read-cache: connect to file watcher
  read-cache: ask file watcher to watch files
  read-cache: put some limits on file watching
  read-cache: get modified file list from file watcher
  read-cache: add config to start file watcher automatically
  read-cache: add GIT_TEST_FORCE_WATCHER for testing
  file-watcher: add --shutdown and --log options
  file-watcher: automatically quit
  file-watcher: support inotify
  file-watcher: exit when cwd is gone
  pkt-line.c: increase buffer size to 8192
  t1301: exclude sockets from file permission check

 .gitignore               |   1 +
 Documentation/config.txt |  14 ++
 Makefile                 |   2 +
 cache.h                  |   8 +
 config.mak.uname         |   1 +
 file-watcher-lib.c (new) | 109 +++++++++++
 file-watcher-lib.h (new) |   9 +
 file-watcher.c (new)     | 483 +++++++++++++++++++++++++++++++++++++++++++++++
 git-compat-util.h        |   3 +
 pkt-line.c               |   4 +-
 pkt-line.h               |   2 +
 read-cache.c             | 338 ++++++++++++++++++++++++++++++++-
 t/t1301-shared-repo.sh   |   3 +-
 trace.c                  |   3 +-
 14 files changed, 969 insertions(+), 11 deletions(-)
 create mode 100644 file-watcher-lib.c
 create mode 100644 file-watcher-lib.h
 create mode 100644 file-watcher.c

-- 
1.8.5.1.208.g05b12ea